# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_dhcppolicyoptionvalue`](#dsc_dhcppolicyoptionvalue): The DSC DhcpPolicyOptionValue resource type. Automatically generated from version 2.0.0.0
* [`dsc_dhcpreservedipoptionvalue`](#dsc_dhcpreservedipoptionvalue): The DSC DhcpReservedIPOptionValue resource type. Automatically generated from version 2.0.0.0
* [`dsc_dhcpscopeoptionvalue`](#dsc_dhcpscopeoptionvalue): The DSC DhcpScopeOptionValue resource type. Automatically generated from version 2.0.0.0
* [`dsc_dhcpserveroptionvalue`](#dsc_dhcpserveroptionvalue): The DSC DhcpServerOptionValue resource type. Automatically generated from version 2.0.0.0
* [`dsc_xdhcpserverauthorization`](#dsc_xdhcpserverauthorization): The DSC xDhcpServerAuthorization resource type. Automatically generated from version 2.0.0.0
* [`dsc_xdhcpserverclass`](#dsc_xdhcpserverclass): The DSC xDhcpServerClass resource type. Automatically generated from version 2.0.0.0
* [`dsc_xdhcpserveroption`](#dsc_xdhcpserveroption): The DSC xDhcpServerOption resource type. Automatically generated from version 2.0.0.0
* [`dsc_xdhcpserveroptiondefinition`](#dsc_xdhcpserveroptiondefinition): The DSC xDhcpServerOptionDefinition resource type. Automatically generated from version 2.0.0.0
* [`dsc_xdhcpserverreservation`](#dsc_xdhcpserverreservation): The DSC xDhcpServerReservation resource type. Automatically generated from version 2.0.0.0
* [`dsc_xdhcpserverscope`](#dsc_xdhcpserverscope): The DSC xDhcpServerScope resource type. Automatically generated from version 2.0.0.0

## Resource types

### `dsc_dhcppolicyoptionvalue`

The DSC DhcpPolicyOptionValue resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_dhcppolicyoptionvalue` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the DHCP option should exist.

##### `dsc_scopeid`

Data type: `Optional[String]`

Scope ID to get policy values from. Do not use it to get an option from server level.

##### `dsc_value`

Data type: `Optional[Array[String]]`

Option data value. Could be an array of string for a multivalued option.

#### Parameters

The following parameters are available in the `dsc_dhcppolicyoptionvalue` type.

##### `dsc_addressfamily`

namevar

Data type: `Enum['IPv4']`

Address family. Currently needs to be IPv4.

##### `dsc_optionid`

namevar

Data type: `Integer[0, 4294967295]`

Option ID, specify an integer between 1 and 255.

##### `dsc_policyname`

namevar

Data type: `String`

Policy Name.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_vendorclass`

namevar

Data type: `String`

Vendor class. Use an empty string for default vendor class.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_dhcpreservedipoptionvalue`

The DSC DhcpReservedIPOptionValue resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_dhcpreservedipoptionvalue` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the DHCP option should exist.

##### `dsc_value`

Data type: `Optional[Array[String]]`

Option data value. Could be an array of string for a multivalued option.

#### Parameters

The following parameters are available in the `dsc_dhcpreservedipoptionvalue` type.

##### `dsc_addressfamily`

namevar

Data type: `Enum['IPv4']`

Address family. Currently needs to be IPv4.

##### `dsc_optionid`

namevar

Data type: `Integer[0, 4294967295]`

Option ID, specify an integer between 1 and 255.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_reservedip`

namevar

Data type: `String`

Reserved IP to set the option value.

##### `dsc_userclass`

namevar

Data type: `String`

User class. Use an empty string for default user class.

##### `dsc_vendorclass`

namevar

Data type: `String`

Vendor class. Use an empty string for default vendor class.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_dhcpscopeoptionvalue`

The DSC DhcpScopeOptionValue resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_dhcpscopeoptionvalue` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the DHCP option should exist.

##### `dsc_value`

Data type: `Optional[Array[String]]`

Option data value.

#### Parameters

The following parameters are available in the `dsc_dhcpscopeoptionvalue` type.

##### `dsc_addressfamily`

namevar

Data type: `Enum['IPv4']`

Address family. Currently needs to be IPv4.

##### `dsc_optionid`

namevar

Data type: `Integer[0, 4294967295]`

Option ID, specify an integer between 1 and 255.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_scopeid`

namevar

Data type: `String`

Scope ID to set the option.

##### `dsc_userclass`

namevar

Data type: `String`

User class. Use an empty string for default user class.

##### `dsc_vendorclass`

namevar

Data type: `String`

Vendor class. Use an empty string for default vendor class.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_dhcpserveroptionvalue`

The DSC DhcpServerOptionValue resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_dhcpserveroptionvalue` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the DHCP option should exist.

##### `dsc_value`

Data type: `Optional[Array[String]]`

Option data value. Could be an array of string for a multivalued option.

#### Parameters

The following parameters are available in the `dsc_dhcpserveroptionvalue` type.

##### `dsc_addressfamily`

namevar

Data type: `Enum['IPv4']`

Address family. Currently needs to be IPv4.

##### `dsc_optionid`

namevar

Data type: `Integer[0, 4294967295]`

Option ID, specify an integer between 1 and 255.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_userclass`

namevar

Data type: `String`

User class. Use an empty string for default user class.

##### `dsc_vendorclass`

namevar

Data type: `String`

Vendor class. Use an empty string for default vendor class.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdhcpserverauthorization`

The DSC xDhcpServerAuthorization resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_xdhcpserverauthorization` type.

##### `dsc_dnsname`

Data type: `Optional[String]`

DHCP Server FQDN

##### `dsc_ipaddress`

Data type: `Optional[String]`

DHCP Server IP Address

#### Parameters

The following parameters are available in the `dsc_xdhcpserverauthorization` type.

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

Whether the DHCP server should be authorised within Active Directory

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdhcpserverclass`

The DSC xDhcpServerClass resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_xdhcpserverclass` type.

##### `dsc_description`

Data type: `Optional[String]`

Class Description

#### Parameters

The following parameters are available in the `dsc_xdhcpserverclass` type.

##### `dsc_addressfamily`

namevar

Data type: `Enum['IPv4']`

Class address family. Currently needs to be IPv4

##### `dsc_asciidata`

namevar

Data type: `String`

Class Data, in ASCII format

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

Whether the DHCP server Class should exist

##### `dsc_name`

namevar

Data type: `String`

Class Name

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_type`

namevar

Data type: `Enum['Vendor', 'User']`

Class Type, Vendor or User

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdhcpserveroption`

The DSC xDhcpServerOption resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_xdhcpserveroption` type.

##### `dsc_addressfamily`

Data type: `Optional[Enum['IPv4']]`

Address family type

##### `dsc_dnsdomain`

Data type: `Optional[String]`

Domain name of DNS Server

##### `dsc_dnsserveripaddress`

Data type: `Optional[Array[String]]`

IP address of DNS Servers

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether option should be set or removed

##### `dsc_router`

Data type: `Optional[Array[String]]`

IP address of the router/default gateway.

#### Parameters

The following parameters are available in the `dsc_xdhcpserveroption` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_scopeid`

namevar

Data type: `String`

ScopeId for which options are set

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdhcpserveroptiondefinition`

The DSC xDhcpServerOptionDefinition resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_xdhcpserveroptiondefinition` type.

##### `dsc_description`

Data type: `Optional[String]`

Option description.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether the DHCP server class should exist.

##### `dsc_multivalued`

Data type: `Optional[Boolean]`

Whether option is multivalued or not.

##### `dsc_name`

Data type: `String`

Option name.

##### `dsc_type`

Data type: `Enum['Byte', 'Word', 'Dword', 'DwordDword', 'IPv4Address', 'String', 'BinaryData', 'EncapsulatedData']`

Option data type.

#### Parameters

The following parameters are available in the `dsc_xdhcpserveroptiondefinition` type.

##### `dsc_addressfamily`

namevar

Data type: `Enum['IPv4']`

Class address family. Currently needs to be IPv4.

##### `dsc_optionid`

namevar

Data type: `Integer[0, 4294967295]`

Option ID, specify a number between 1 and 255.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_vendorclass`

namevar

Data type: `String`

Vendor class. Use an empty string for standard option class.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdhcpserverreservation`

The DSC xDhcpServerReservation resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_xdhcpserverreservation` type.

##### `dsc_addressfamily`

Data type: `Optional[Enum['IPv4']]`

Address family type

##### `dsc_clientmacaddress`

Data type: `String`

Client MAC Address to set on the reservation

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether option should be set or removed

##### `dsc_name`

Data type: `Optional[String]`

Reservation name

#### Parameters

The following parameters are available in the `dsc_xdhcpserverreservation` type.

##### `dsc_ipaddress`

namevar

Data type: `String`

IP address of the reservation for which the properties are modified

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_scopeid`

namevar

Data type: `String`

ScopeId for which reservations are set

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xdhcpserverscope`

The DSC xDhcpServerScope resource type.
Automatically generated from version 2.0.0.0

#### Properties

The following properties are available in the `dsc_xdhcpserverscope` type.

##### `dsc_addressfamily`

Data type: `Optional[Enum['IPv4']]`

Address family type

##### `dsc_description`

Data type: `Optional[String]`

Description of DHCP Scope

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether scope should be set or removed

##### `dsc_ipendrange`

Data type: `String`

Ending address to set for this scope

##### `dsc_ipstartrange`

Data type: `String`

Starting address to set for this scope

##### `dsc_leaseduration`

Data type: `Optional[String]`

Time interval for which an IP address should be leased

##### `dsc_name`

Data type: `String`

Name of DHCP Scope

##### `dsc_state`

Data type: `Optional[Enum['Active', 'Inactive']]`

Whether scope should be active or inactive

##### `dsc_subnetmask`

Data type: `String`

Subnet mask for the scope specified in IP address format

#### Parameters

The following parameters are available in the `dsc_xdhcpserverscope` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_scopeid`

namevar

Data type: `String`

ScopeId for the given scope

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

