require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xdhcpserveroption',
  dscmeta_resource_friendly_name: 'xDhcpServerOption',
  dscmeta_resource_name: 'MSFT_xDhcpServerOption',
  dscmeta_module_name: 'xDhcpServer',
  dscmeta_module_version: '2.0.0.0',
  docs: 'The DSC xDhcpServerOption resource type.
         Automatically generated from version 2.0.0.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_addressfamily: {
      type: "Optional[Enum['IPv4']]",
      desc: 'Address family type',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_dnsdomain: {
      type: 'Optional[String]',
      desc: 'Domain name of DNS Server',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_dnsserveripaddress: {
      type: 'Optional[Array[String]]',
      desc: 'IP address of DNS Servers',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
    dsc_router: {
      type: 'Optional[Array[String]]',
      desc: 'IP address of the router/default gateway.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
    dsc_scopeid: {
      type: 'String',
      desc: 'ScopeId for which options are set',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: 'Whether option should be set or removed',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
